<?php
/**
 * Query relay from SOAP server to client
 * QueryRelay.php
 * Returns the list of subscribers to an archive.
 * Requires Pear SOAP.
 * Written to circumvent a bug in some versions of Pear SOAP.
 * Also an HTML way to get the subscriber list.
 * Version 0.0.4
 * Copyright (c) 2001-2002 Alexis Grandemange
 * Mail: alexis.grandemange@pagebox.net
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; version
 * 2.1 of the License.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 * A copy of the GNU Lesser General Public License lesser.txt should be
 * included in the distribution.
 */
include("pagebox.inc");
if (!file_exists("pbArchives.pb")) {
    echo "Archive not found";
    return;
}
$s = implode("", @file("pbArchives.pb"));
$PbArchivesObj = unserialize($s);
pblog("pbArchives restored");
if (!key_exists("arch", $HTTP_GET_VARS)) {
    echo "arch parameter not set";
    return;
}
if (!key_exists("deploy", $HTTP_GET_VARS)) {
    echo "deploy parameter not set";
    return;
}
$archive = $HTTP_GET_VARS["arch"];
$deployURL = $HTTP_GET_VARS["deploy"];
$ra = repoQuery($PbArchivesObj, $archive, $deployURL);
if ($ra == NULL) {
    echo "Archive not found";
    return;
}
foreach($ra as $item) {
    echo $item . "\r\n";
}
?>