<!--
 Repository publication page.
 publisher.php
 Lists, uploads and removes archives from the repository.
 Version 0.0.3
 Changes:
 - 0.0.3 Documentation URL
 - 0.0.4 Bux fixes (PHP 4.1/4.2)
 Copyright (c) 2001-2002 Alexis Grandemange
 Mail: alexis.grandemange@pagebox.net
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; version
 2.1 of the License.
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU Lesser General Public License for more details.
 A copy of the GNU Lesser General Public License lesser.txt should be
 included in the distribution.
 -->
<html>
<head>
<meta http-equiv="Cache-Control" content="no-cache">
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta name="Description" content="Publisher of PHP Pagebox repository">
<meta name="keywords" content="Publish, PHP, Pagebox, repository">
<link rel="stylesheet" href="pagebox.css" type="text/css">
<script src="pagebox.js"></script>
<title>Publisher of PHP Pagebox repository</title>
</head>
<body>
<?php
include("archive.inc");
if (!lock("publisher.php", $HTTP_SERVER_VARS["REMOTE_USER"], $HTTP_SERVER_VARS["REMOTE_ADDR"])) {
  $status = "Repository locked - retry later";
} else {
/**
 * Checks that the user is a Repository registered user (defined in users.rep).
 * If users.rep doesn't exist, no user checking is performed.
 * You should define users.rep for production.
 */
$allowed = false;
$status = "";
if (file_exists("users.rep")) {
  $fusers = fopen ("users.rep", "r");
  while (!feof ($fusers)) {
    $user = rtrim(fgets($fusers, 255));
    if ($user == rtrim($HTTP_SERVER_VARS["REMOTE_USER"])) {
      $allowed = true;
      break;
    }
  }
  fclose ($fusers);
  if (!$allowed) {
    $status = $HTTP_SERVER_VARS["REMOTE_USER"] . " not allowed";
  }
} else {
  $status = "Unsecure setting: users.rep doesn't exist";
  $allowed = true;
}
/**
 * Request handling.
 * Queried in POST mode by itself.
 * In case of upload, moves the archive in upload.rep directory.
 */
if ($allowed) {
  $download = "";
  $requri = $HTTP_SERVER_VARS["REQUEST_URI"];
  $begin = substr($requri, 0, 7);
  if ($begin == "http://") {
    $requri = substr($requri, 7);
    $download = str_replace("repository", "download", dirname($requri));
  } else {
    $download = $HTTP_SERVER_VARS["HTTP_HOST"] . str_replace("repository", "download", dirname($requri));
  }
  // echo $download . "<br/>";
  $archRep = restore_archives($download);
  if (key_exists("isForce", $HTTP_POST_VARS)) {
    if ($HTTP_POST_VARS["isForce"] == "true") {
      $status = $archRep->delete($HTTP_POST_VARS["arch"], true);
      audit("force(" . $HTTP_POST_VARS["arch"] . ") " . $status,
        $HTTP_SERVER_VARS["REMOTE_USER"], $HTTP_SERVER_VARS["REMOTE_ADDR"]);
    } else {
      $status = $archRep->delete($HTTP_POST_VARS["arch"], false);
      audit("delete(" . $HTTP_POST_VARS["arch"] . ") " . $status,
        $HTTP_SERVER_VARS["REMOTE_USER"], $HTTP_SERVER_VARS["REMOTE_ADDR"]);
    }
    save_archives($archRep, $download);
  } elseif (key_exists("Publish", $HTTP_POST_VARS) &&
    ($HTTP_POST_VARS["Publish"] == "Publish") && ($HTTP_POST_FILES["arch"] != NULL)) {
    $name = $HTTP_POST_FILES["arch"]["name"];
    if ($name != NULL) {
      $tempName = $HTTP_POST_FILES["arch"]["tmp_name"];
      if ($status == "The archive already exists and doesn't belongs to you") {
        unlink($tempName);
      } else {
        move_uploaded_file($tempName, $name);
        if (file_exists("upload.rep")) {
          $fupload = fopen("upload.rep", "r");
          $upload_dir = fgets($fupload, 255);
          fclose($fupload);
          if (file_exists("../download/" . $name)) {	// Shouldn't occur
            unlink("../download/" . $name);
          }
          $tempName = $upload_dir . $name;
          rename($tempName, "../download/" . $name);
        } else {
          rename($name, "../download/" . $name);
        }
      }
      $status = $archRep->add($name, $user, $HTTP_POST_VARS["docURL"]);
      audit("add(" . $name . ", " . $HTTP_POST_VARS["docURL"] . ") " . $status,
        $HTTP_SERVER_VARS["REMOTE_USER"], $HTTP_SERVER_VARS["REMOTE_ADDR"]);
    }
    save_archives($archRep, $download);
  }
}
} // lock
?>
<table width="100%"><tr>
<td align="left" width="8%">
<a href="http://pagebox.net/php/php-index.html" style="text-decoration:none;background:white;color:white">
<img src="logo.gif" alt="Publisher of PHP Pagebox repository" border="0"></a></td>
<td align="left"><h1>Publisher</h1></td>
<td align="right"><a href="admin.php" alt="Administration of PHP Pagebox repository">Administration</a></td>
<td align="right"><a href="subscriber.php" alt="Subscriber of PHP Pagebox repository">Subscriber</a></td>
<td align="right"><a href="select.php" alt="Archive Subscriber of PHP Pagebox repository">Select</a></td>
<td align="right"><a href="audit.php" alt="Audit of PHP Pagebox repository">Audit</a></td>
<td align="right"><a href="batch.php" alt="Batch report on PHP Pagebox repository">Batch</a></td>
<td align="right"><a href="environment.php" alt="PHP environment">Environment</a></td>
<td align="right"><a href="mailto:support@pagebox.net">
<img src="mail.gif" alt="support@pagebox.net" border="0"></a></td></tr></table>
<table width="100%"><tr bgcolor="maroon">
<th width="8%">Action</th><th width="8%">&nbsp;</th>
<th width="10%">Archive</th><th width="20%">Date</th>
<th width="14%">Owner</th><th width="22%">Documentation</th><th width="8%">Size</th></tr>
<?php
/**
 * Lists archives belonging to the user (if users.rep is defined).
 */
if ($status != "Repository locked - retry later") {
  if ($allowed && ($archRep->archives != NULL)) {
    while (list($key, $value) = each ($archRep->archives)) {
      if (($user != "") && ($user != $value)) {
        continue;
      }
      echo '<tr><td width="8%"><input type="button" name="Delete" value="Delete" onClick=del("', $key, '")></td>';  
      echo '<td width="8%"><input type="button" name="Force" value="Force" onClick=forceDel("', $key, '")></td>';
      echo '<td width="10%">', $key, '</td>';
      echo '<td width="20%">', date("d M Y h:i:s", filemtime("../download/" . $key)), '</td>';
      echo '<td width="14%">', $value, '</td>';
      echo '<td width="22%"><a href="', $archRep->docs[$key], '">', $archRep->docs[$key], '</a></td>';
      echo '<td width="8%">', filesize("../download/" . $key), '</td></tr>';
    }
  }
  unlock();
}
?>
</table>
<form enctype="multipart/form-data" action="publisher.php" method="post">
<input type="hidden" name="MAX_FILE_SIZE" value="500000">
<table width="100%"><tr>
<td width="20%">Publish this archive:</td><td width="60%"><input name="arch" type="file" size="60"></td>
<td width="10%"><input type="submit" name="Publish" value="Publish"></td>
<td width="10%"><input type="submit" name="Refresh" value="Refresh"></td></tr>
<tr><td width="20%">Documentation URL:</td><td width="60%"><input type="text" size="60" name="docURL"/></td>
</tr></table>
</form>
<p class="timestamp"><?= $status ?></p>
<p align="center">&#169;2002 Alexis Grandemange.
<font class="timestamp">Last modified
<script>document.write(document.lastModified);</script>.
</font></p>
<!-- Hidden form used by pagebox.js. -->
<form name="hiddenDel" method="post" action="publisher.php">
<input type="hidden" name="arch"/>
<input type="hidden" name="isForce"/>
</form>
</body>
</html>